import 'package:get/get.dart';

abstract class BaseController extends GetxController {
  Rx<Map<String, List<Map<String, Object>>>> rxData =
      Rx<Map<String, List<Map<String, Object>>>>();
  Map<String, List<Map<String, Object>>> _data = {};

   bool isComponent = true; //default component ui

  Future<Map<String, List<Map<String, Object>>>> loadData();

  Future<Map<String, List<Map<String, Object>>>> getDataAsync() async {
    return getData();
  }

  Map<String, List<Map<String, Object>>> getData() {
    if (_data == null) _data = {};
    return _data;
  }

  void setData(Map<String, List<Map<String, Object>>> data) {
    if(data == null)
      {
        _data = {};//empty list
      }
    else{
      _data = data;
    }
  }

  void clearData() {
    if (_data != null) {
      _data.clear();
      _data = null;
    }
    if (rxData != null) {
      if (rxData.value != null) {
        rxData.value.clear();
      }
      rxData.value = null;
    }
  }
}
